Attribute VB_Name = "modPath"
Option Explicit

'Copyright (c) 2007, Alasdair King
'All rights reserved.
'
'Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
'
'    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
'    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
'    * Neither the name of [Alasdair] nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
'
'THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

'Changelog
'       28 Aug 2009             Made GetAppPath return String explicitly.

Public settingsPath As String ' the settings directory for the application
Public runningLocal As Boolean ' whether we're running off the local folder
    'only
Public commonSettingsPath As String ' the settings directory for the WebbIE applications
Public nonRoamingSettingsPath As String ' the settings directory for non-roaming data
    '(e.g. Local Settings)

'SHGetSpecialFolderLocation
'Returns the Folder ID of the user's My Documents folder (or another folder indicated
'by CSIDL)
Private Declare Function SHGetSpecialFolderLocation Lib "Shell32" (ByVal hwnd As Long, ByVal nFolder As Long, ppidl As Long) As Long
'SHGetPathFromIDList
'Returns the path (string) from the folder ID obtained by SHGetSpecialFolderLocation
Public Declare Function SHGetPathFromIDList Lib "Shell32" Alias "SHGetPathFromIDListA" (ByVal Pidl As Long, ByVal pszPath As String) As Long

' constants for Shell.NameSpace method -- these are the "special folders"
'contained in the Windows shell
Public Const CSIDL_DESKTOP = &H0 ' Desktop
Public Const CSIDL_INTERNET = &H1 ' The internet
Public Const CSIDL_PROGRAMS = &H2 ' Shortcuts in the Programs menu
Public Const CSIDL_CONTROLS = &H3 ' Control Panel
Public Const CSIDL_PRINTERS = &H4 ' Printers
Public Const CSIDL_PERSONAL = &H5 ' Shortcuts to Personal files
Public Const CSIDL_FAVORITES = &H6 ' Shortcuts to favorite folders
Public Const CSIDL_STARTUP = &H7 ' Shortcuts to apps that start at boot Time
Public Const CSIDL_RECENT = &H8 ' Shortcuts to recently used docs
Public Const CSIDL_SENDTO = &H9 ' Shortcuts for the SendTo menu
Public Const CSIDL_BITBUCKET = &HA ' Recycle Bin
Public Const CSIDL_STARTMENU = &HB ' User-defined items in Start Menu
Public Const CSIDL_DESKTOPDIRECTORY = &H10 ' Directory with all the desktop shortcuts
Public Const CSIDL_DRIVES = &H11 ' My Computer
Public Const CSIDL_NETWORK = &H12 ' Network Neighborhood virtual folder
Public Const CSIDL_NETHOOD = &H13 ' Directory containing objects in the network neighborhood
Public Const CSIDL_FONTS = &H14 ' Installed fonts
Public Const CSIDL_TEMPLATES = &H15 ' Shortcuts to document templates
Public Const CSIDL_COMMON_STARTMENU = &H16 ' Directory with items in the Start menu for all users
Public Const CSIDL_COMMON_PROGRAMS = &H17 ' Directory with items in the Programs menu for all users
Public Const CSIDL_COMMON_STARTUP = &H18 ' Directory with items in the StartUp submenu for all users
Public Const CSIDL_COMMON_DESKTOPDIRECTORY = &H19 ' Directory with items on the desktop of all users
Public Const CSIDL_APPDATA = &H1A ' Folder for application-specific data
Public Const CSIDL_PRINTHOOD = &H1B ' Directory with references to printer links
Public Const CSIDL_LOCAL_APPDATA = &H1C          '{user name}\Local Settings\Application Data (non roaming)
Public Const CSIDL_ALTSTARTUP = &H1D ' (DBCS) Directory corresponding to user 's nonlocalized Startup program group
Public Const CSIDL_COMMON_ALTSTARTUP = &H1E ' (DBCS) Directory with Startup items for all users
Public Const CSIDL_COMMON_FAVORITES = &H1F ' Directory with all user's favorit items
Public Const CSIDL_INTERNET_CACHE = &H20 ' Directory for temporary internet Files
Public Const CSIDL_COOKIES = &H21 ' Directory for Internet cookies
Public Const CSIDL_HISTORY = &H22 ' Directory for Internet history items
Public Const CSIDL_COMMON_APPDATA = &H23          'All Users\Application Data
Public Const CSIDL_WINDOWS = &H24                 'GetWindowsDirectory()
Public Const CSIDL_SYSTEM = &H25                  'GetSystemDirectory()
Public Const CSIDL_PROGRAM_FILES = &H26           'C:\Program Files
Public Const CSIDL_MYPICTURES = &H27                 'C:\Program Files\My Pictures
Public Const CSIDL_PROFILE = &H28                 'USERPROFILE
Public Const CSIDL_SYSTEMX86 = &H29               'x86 system directory on RISC
Public Const CSIDL_PROGRAM_FILESX86 = &H2A        'x86 C:\Program Files on RISC
Public Const CSIDL_PROGRAM_FILES_COMMON = &H2B    'C:\Program Files\Common
Public Const CSIDL_PROGRAM_FILES_COMMONX86 = &H2C 'x86 Program Files\Common on RISC
Public Const CSIDL_COMMON_TEMPLATES = &H2D        'All Users\Templates
Public Const CSIDL_COMMON_DOCUMENTS = &H2E        'All Users\Documents
Public Const CSIDL_COMMON_ADMINTOOLS = &H2F       'All Users\Start Menu\Programs\Administrative Tools
Public Const CSIDL_ADMINTOOLS = &H30              '{user name}\Start Menu\Programs\Administrative Tools

Public Const CSIDL_FLAG_CREATE = &H8000           'combine with CSIDL_ value to force create on SHGetSpecialFolderLocation()
Public Const CSIDL_FLAG_DONT_VERIFY = &H4000      'combine with CSIDL_ value to force create on SHGetSpecialFolderLocation()
Public Const CSIDL_FLAG_MASK = &HFF00             'mask for all possible flag values

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpSectionName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long


Public Sub DetermineSettingsPath(Optional ByVal companyName As String, Optional ByVal productName As String, Optional ByVal version As String)
    'works out whether we are running on a memory stick/standalone or as an
    'installed application.
    On Error Resume Next
    Dim fso As FileSystemObject
    Dim got As String
    Dim gotLen As Long
    Dim key As String
    Dim section As String
    Dim Path As String
    
    'Get any override values for company, version and application name from the program .ini file, if any.
    'Otherwise use the values passed.
    got = Space(255) & Chr(0)
    gotLen = GetPrivateProfileString("ApplicationDataPath", "Company", companyName, got, Len(got), GetAppPath & "\" & App.EXEName & ".ini")
    got = Trim(left(got, gotLen))
    If Len(companyName) = 0 Then
        If Len(got) > 0 Then companyName = got Else companyName = App.companyName
    End If
    got = Space(255) & Chr(0)
    gotLen = GetPrivateProfileString("ApplicationDataPath", "ApplicationName", productName, got, Len(got), GetAppPath & "\" & App.EXEName & ".ini")
    got = Trim(left(got, gotLen))
    If Len(productName) = 0 Then
        If Len(got) > 0 Then productName = got Else productName = App.productName
    End If
    got = Space(255) & Chr(0)
    gotLen = GetPrivateProfileString("ApplicationDataPath", "Version", version, got, Len(got), GetAppPath & "\" & App.EXEName & ".ini")
    got = Trim(left(got, gotLen))
    If Len(version) = 0 Then
        If Len(got) > 0 Then version = got Else version = App.Major
    End If

    Set fso = New FileSystemObject
    If fso.FileExists(GetAppPath & "\installed.ini") Then
        runningLocal = False
    Else
        'try checking for local INI file to indicate not running from stick
        got = Space(255) & Chr(0)
        key = "RunAsInstalled" & Chr(0)
        section = "Program" & Chr(0)
        Path = GetAppPath & "\" & App.EXEName & ".ini" & Chr(0)
        gotLen = GetPrivateProfileString(section, key, "0" & Chr(0), got, Len(got), Path)
        If gotLen > 0 Then got = left(got, gotLen)
        If CBool(got) Then
            'ini file indicates we should run as installed version
            runningLocal = False
        Else
            'running from a memory stick or other non-installed location
            runningLocal = True
        End If
    End If
    If runningLocal Then
        'running from a memory stick or other non-installed location
        settingsPath = GetAppPath & "\Settings"
        nonRoamingSettingsPath = settingsPath
        'need to create
        If Not fso.FolderExists(settingsPath) Then Call fso.CreateFolder(settingsPath)
    Else
        'run as installed version
        settingsPath = GetSpecialFolderPath(CSIDL_APPDATA)
        '3.12.2 Can't access Local Appdata - it's per-machine.
        nonRoamingSettingsPath = GetSpecialFolderPath(CSIDL_APPDATA) ' GetSpecialFolderPath(CSIDL_LOCAL_APPDATA)
    End If
    settingsPath = settingsPath & "\" & companyName
    If Not fso.FolderExists(settingsPath) Then Call fso.CreateFolder(settingsPath)
    nonRoamingSettingsPath = nonRoamingSettingsPath & "\" & companyName
    If Not fso.FolderExists(nonRoamingSettingsPath) Then Call fso.CreateFolder(nonRoamingSettingsPath)
    commonSettingsPath = settingsPath & "\Common"
    If Not fso.FolderExists(commonSettingsPath) Then Call fso.CreateFolder(commonSettingsPath)
    settingsPath = settingsPath & "\" & productName
    If Not fso.FolderExists(settingsPath) Then Call fso.CreateFolder(settingsPath)
    nonRoamingSettingsPath = nonRoamingSettingsPath & "\" & productName
    If Not fso.FolderExists(nonRoamingSettingsPath) Then Call fso.CreateFolder(nonRoamingSettingsPath)
    settingsPath = settingsPath & "\" & version
    If Not fso.FolderExists(settingsPath) Then Call fso.CreateFolder(settingsPath)
    nonRoamingSettingsPath = nonRoamingSettingsPath & "\" & version
    If Not fso.FolderExists(nonRoamingSettingsPath) Then Call fso.CreateFolder(nonRoamingSettingsPath)
    Set fso = Nothing
End Sub

Public Function GetSpecialFolderPath(CSIDL As Long) As String
'returns the special folder indicated by the CSIDL constant
    On Error Resume Next
    Dim Path As String
    Dim result As Long
    Dim referenceID As Long
    
    'work out where to save them to:
    Path = Space(260)
    result = SHGetSpecialFolderLocation(0, CSIDL, referenceID)
    result = SHGetPathFromIDList(referenceID, Path)
    'assertion: path now contains path to special folder
    Path = Trim(Path)
    'take off final null character which trim has left behind
    Path = Replace(Path, Chr(0), "")
    'return
    GetSpecialFolderPath = Path
End Function

Public Function GetAppPath() As String
    On Error Resume Next
    'work out some paths for use
    GetAppPath = App.Path
    If right(GetAppPath, 1) = "\" Then
        GetAppPath = left(GetAppPath, Len(GetAppPath) - 1)
    End If
End Function

Public Function GetSettingIni(appName As String, section As String, key As String, default As String) As String
    On Error Resume Next
    Dim value As String
    Dim size As Long
    Dim nullTerminatedDefault As String
    Dim Path As String
    
    nullTerminatedDefault = default & Chr(0)
    section = section & Chr(0)
    key = key & Chr(0)
    value = Space(256) & Chr(0)
    Path = settingsPath & "\" & appName & ".ini" & Chr(0)
    size = GetPrivateProfileString(section, key, nullTerminatedDefault, value, Len(value), Path)
    If size = 0 Then
        'nothing read
        GetSettingIni = default
    Else
        'read okay
        GetSettingIni = left(value, size)
    End If
End Function

Public Sub SaveSettingIni(appName As String, section As String, key As String, value As String)
    On Error Resume Next
    Dim Path As String
    
    section = section & Chr(0)
    key = key & Chr(0)
    value = value & Chr(0)
    Path = settingsPath & "\" & appName & ".ini"
    
    Call WritePrivateProfileString(section, key, value, Path)
End Sub

Public Function ReadAppEXEIni(section As String, key As String, default As String) As String
    On Error Resume Next
    Dim iniFile As String
    Dim got As String
    
    iniFile = GetAppPath & "\" & App.EXEName & ".ini" & Chr(0)
    section = section & Chr(0)
    key = key & Chr(0)
    default = default & Chr(0)
    got = Space(255) & Chr(0)
    
    Call GetPrivateProfileString(section, key, default, got, Len(got), iniFile)
    got = Replace(got, Chr(0), "")
    got = Trim(got)
    ReadAppEXEIni = got
End Function
